//VERSIÓN4 del proyecto MOODLAMP Reactor de Manufactura Digital por Josúe Gudiel.
//Versión final de la Moodlamp. Entre las implementaciones hay una correción de colores
//en el modo AUTO y reducción en el tiempo de carga.


//Incluir la librería para manipular los neopixeles
#include <Adafruit_NeoPixel.h>
#define NUM_LEDS 11     //Número de Neos a usarse
#define PIN 2           //Al pin al que estarán conectados

//Incluir la librería DTH para la temperatura
#include <DHT.h>
#include <DHT_U.h>
#define DHTPIN 4      //Entrada del termómetro
#define DHTTYPE DHT11
DHT dht(DHTPIN, DHTTYPE);



//Definir constantes y variables
//Generales
const int BOTON = 3;
const int NEOS = 10;

//Establecer en modo manual
int PULSO = 0;

//Para modo manual    
int i;
int POT1 = A3;
int POT2 = A4;
int POT3 = A5;
int V1;
int V2;
int V3;
int R;
int G;
int B;

//Para modo automático
int HUM;
int TEMP;
int LUZ = A2;
int VOLT;
int R2;
int G2;
int B2;


//Definir la tira como pixels
Adafruit_NeoPixel pixels(NUM_LEDS, PIN, NEO_GRB + NEO_KHZ800);;

//Función setup
void setup(){
  //Inicializar la tira
  pixels.begin();

  //Inicializar los receptores
  pinMode(BOTON, INPUT);    //Boton de cambio de modo
  dht.begin();              //Temperatura y humedad

  //Inicializar potenciometros
  pinMode(POT1, INPUT);
  pinMode(POT2, INPUT);
  pinMode(POT3, INPUT);

  //Inicializar monitor serial
  Serial.begin(9600);

  //Recibir mediante fotoresistencia
  pinMode(LUZ, INPUT);
  
}

void loop() {
  //Código para el cambio de modo
  int PULSADOR = digitalRead(BOTON);
  if(PULSADOR == HIGH){
    //Si esta en modo manual
    if(PULSO == 0){
      PULSO = 1; //Un cambio a pulso 1 es un cambio al modo automático
    }
    //Si esta en modo automático
    else if(PULSO == 1){
      PULSO = 0; //Un cambio a pulso 0 es un cambio al modo manual
    }
  }
  while(digitalRead(BOTON) == HIGH);  //Mantendra al código de avanzar mientras hayan rebotes


  //Modos de uso
  if (PULSO == 0){
  MANUAL();  
  }
  else if (PULSO == 1){
  AUTO();
  }
  
}




//Funcion del MODO MANUAL
void MANUAL(){
    //Lectura de los potenciometros
  V1 = analogRead(POT1);
  V2 = analogRead(POT2);
  V3 = analogRead(POT3);

  //Corrector de voltaje
    //Voltaje para rojo
  if(V1 < 80){
    V1 = 0;
  }
  else if(V1 > 975){
    V1 = 1023;
  }
  
    //Voltaje para verde
  if(V2 < 50){
    V2 = 0;
  }
  else if(V2 > 975){
    V2 = 1023;
  }

    //Voltaje para azul
  if(V3 < 50){
    V3 = 0;
  }
  else if(V3 > 975){
    V3 = 1023;
  }

  //COnversión a valores RGB
  R = (V1* 0.249);
  G = (V2* 0.249);
  B = (V3* 0.249);

  //Mostrar valores para los RGB en el serial
  Serial.print("Colores:");
  Serial.print("  R");
  Serial.print(R);    //Imprimir el rojo
  Serial.print("  G");
  Serial.print(G);    //Imprimir el verde
  Serial.print("  B");
  Serial.println(B);    //Imprimir el azul

  //Setear color
  for(i = NEOS; i >= 0; i--){
  pixels.setPixelColor(i, pixels.Color(R, G, B));
  pixels.show();
  }
 delay(300);
}



//Modo AUTOMÁTICO
void AUTO(){
  //Lectura de temperatura, luz y humedad
  float HUM = dht.readHumidity();
  float TEMP = dht.readTemperature();
  VOLT = analogRead(LUZ);

G2 = VOLT*0.363; //VERDE;

//Conversión a modo RGB

//Luz y temperatura/humedad
int CAMBIO = 0;
if(VOLT < 100){
  CAMBIO = 2;
}
else if(VOLT >= 100){
  CAMBIO = -4;
}

TEMP = TEMP + CAMBIO;
HUM = HUM + CAMBIO;

 //Corrección de datos
 //Rojo con temperatura
 if(TEMP < 18){
  TEMP == 18; 
 }
else if (TEMP > 25){
  TEMP == 25;
 }

//Verde con luz
if(VOLT > 700){
  VOLT = 700;
}

//Azul con humedad
if(HUM < 65){
  HUM = 65;
}
else if(HUM > 80){
  HUM = 80;
}


//Colores
B2 = 17*HUM -1105;//AZUL
R2 = 23.17*TEMP - 417.06; //ROJO
G2 = VOLT*0.363; //VERDE;

 //Mostrar valores para los RGB en el serial
Serial.print("Colores:");
Serial.print("  R");
Serial.print(R2);    //Imprimir el rojo
Serial.print("  G");
Serial.print(G2);    //Imprimir el verde
Serial.print("  B");
Serial.println(B2);    //Imprimir el azul

//Setear color
for(i = NEOS; i >= 0; i--){
pixels.setPixelColor(i, pixels.Color(R2, G2, B2));
pixels.show();
 }
delay(300);
}
